#include "calculate.bi"
#include "inputUsing.bi"

sub koord
  line (400, 599)-(400, 100), 7
  line -(395, 105), 7
  line (400, 100)-(405, 105), 7
  line (0, 350)-(799, 350), 7
  line -(794, 345), 7
  line (799, 350)-(794, 355), 7
  for i as integer = 50 to 750 step 50
    line (i, 346)-(i, 354), 7
  next
  for i as integer = 150 to 550 step 50
    line (396, i)-(404, i), 7
  next
end sub

function errorString as string
  select case as const Calculate.CalcError
    case Calculate.ErrorNoValue
      return "kein Wert angegeben"
    case Calculate.ErrorMissingBrace
      return "fehlende Klammer"
    case Calculate.ErrorMissingNumber
      return "fehlende Zahl"
    case Calculate.ErrorWrongDecimalPoint
      return "fehlerhafter Dezimalpunkt"
    case Calculate.ErrorWrongExponent
      return "fehlerhafte Exponentschreibweise"
    case Calculate.ErrorIllegalSymbol
      return "unerlaubtes Zeichen"
    case Calculate.ErrorNotANumber
      return "fehlerhafte Zahl"
    case Calculate.ErrorUndefinedFunction
      return "undefinierte Funktion"
    case Calculate.ErrorUndefinedVariable
      return "undefinierte Variable"
    case Calculate.ErrorOverwriteFunction
      return "Funktion kann nicht ueberschrieben werden"
    case Calculate.ErrorIllegalValue
      return "unerlaubter Funktionswert"
    case else
      return "<unbekannter Fehler>"
  end select
end function

dim as string term, ret
dim as double wert, wertAlt

screenres 800, 600
koord
do
  wertAlt = 999
  term = inputUsing (2, 2, "Funktionsterm (ESC beendet das Programm): f(x) = ", term, _
                     "0a+++-+*+/+^+(+)+.c,.x" & chr(27) & "s" & chr(107), ret, 49,, 50)
  if ret = chr(27) or ret = chr(255, 107) then exit do
  cls
  koord
  for i as integer = 0 to 799
    wert = calc("x=" & (i-400)/50 & ";" & term)
    if Calculate.CalcError > 0 then
      wertAlt = 999
    else
      if wert > -5 and wert <= 5 then
        if wertAlt > -5 and wertAlt <= 5 then line -(i, 350 - wert*50) else pset (i, 350 - wert*50)
        wertAlt = wert
      end if
    end if
  next
  if Calculate.CalcError > 0 and Calculate.CalcError <> Calculate.ErrorIllegalValue then
    locate 3, 2
    draw string (8, 24), "FEHLER " & ErrorString & " (" & Calculate.CalcErrorTerm & ")", 12
  end if
loop
